jQuery( document ).ready( function( $ ) { 
	'use strict';

	// declared namespace to prevent conflict
	$.sp_woocommerce_dropshop_admin_scripts = {
		
		init: function() {			
			// reveal custom option area when click/enabled
			function customOptions() {
				$( '.sp-woocommerce-dropshop-custom-option' ).click( function() {
					// first check if checkbox is checked 
					if ( $( this ).is( ':checked' ) ) {
						$( '.sp-woocommerce-dropshop-option-area' ).slideDown( 'fast' );	
					} else {
						$( '.sp-woocommerce-dropshop-option-area' ).slideUp( 'fast' );
					}
				});
			}
			customOptions();
			
			// reveal orientation options
			function orientationOptions() {
				$( '.sp-woocommerce-dropshop-orientation-select' ).change( function() {
					// get the value of the selected
					var option = $( 'option:selected', this ).val(),
						cartFollowArea = $( 'p.cart-follow-area' ),
						autoHideArea = $( 'div.autohide-area' );
					
					if ( option === 'vertical' ) {
						cartFollowArea.slideDown( 'fast' );
						autoHideArea.slideUp( 'fast' );
					} else if ( option === 'horizontal' ) {
						cartFollowArea.slideUp( 'fast' );
						autoHideArea.slideDown( 'fast' );
					}
				});
			}
			orientationOptions();

			// function to load the colorpicker
			function loadColorPicker() {
				// make sure the function exists WP 3.5+
				if ( $.fn.wpColorPicker ) {					
					$( '.sp-woocommerce-dropshop-color-input' ).wpColorPicker();

					// a workaround fix to prevent colorpicker showing two times
					$( '.sp-woocommerce-dropshop-option-area > .wp-picker-container' ).each( function() {
						$( '> .wp-color-result', this ).hide();
					});
				}				
			}
			loadColorPicker();
			
			// recheck/rebind elements on ajax callback 
			$( document ).ajaxSuccess( function( e, xhr, settings ) {
				var widget_id_base = 'sp-woocommerce-drop-shop-widget';
			
				if ( settings.data.search( 'action=save-widget' ) !== -1 && settings.data.search( 'id_base=' + widget_id_base ) !== -1 ) {
					loadColorPicker();
					orientationOptions();
					customOptions();

					// first check if checkbox is checked 
					if ( $( '.sp-woocommerce-dropshop-custom-option' ).is( ':checked' ) ) {
						$( '.sp-woocommerce-dropshop-option-area' ).show();	
					} else {
						$( '.sp-woocommerce-dropshop-option-area' ).hide();
					}
				}				
			});			
		
		} // close init	
	}; // close namespace
	
	$.sp_woocommerce_dropshop_admin_scripts.init();		
});